-- cash by packetlss

import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";

-- register and handle shell commands
function shellCommands()

	shellCmd = Turbine.ShellCommand();

	function shellCmd:Execute(cmd, args)
		if (string.lower(cmd) == "cash") then
			local pos1 = string.find(args, " ", 0, true);
			local command;
			if pos1 ~= nil and pos1 > 0 then
				command = string.lower(string.sub(args, 1, pos1 - 1));
			else
				command = string.lower(args);
			end

			if (command == "show") then

				Turbine.Shell.WriteLine("cash: initial: " .. moneyToString(initialCash)); 

				local currentCash = playerAttributes:GetMoney();
				Turbine.Shell.WriteLine("cash: delta: " .. moneyToString(currentCash - initialCash)); 
			
			elseif (command=="reset") then

				initialCash = playerAttributes:GetMoney();
				Turbine.Shell.WriteLine("cash: reset: new initial: " .. moneyToString(initialCash));

			elseif (command == "list") then

				local totalCash = 0;
				local currentCash = playerAttributes:GetMoney();
				playerList[playerName] = currentCash;
		
				for k,v in pairs(playerList) do
	 
					Turbine.Shell.WriteLine("cash: " ..  k  .. " - " .. moneyToString(v));
					totalCash = totalCash + v;
	
				end
	
				Turbine.Shell.WriteLine("cash: total - " .. moneyToString(totalCash));
		
			else
				Turbine.Shell.WriteLine("cash v" .. Plugins["Cash"]:GetVersion() .. " by packetlss loaded.");
				Turbine.Shell.WriteLine("  /cash show  - show current balance since last login or reset");
				Turbine.Shell.WriteLine("  /cash reset - reset current balance");
				Turbine.Shell.WriteLine("  /cash list - list cash on other characters");
			end
		end
	end

	function shellCmd:GetHelp()
		return "Cash: access Cash commands";
	end
	
	function shellCmd:GetShortHelp()
		return "Cash.";
	end
	
	Turbine.Shell.AddCommand("Cash", shellCmd);

end

function moneyToString( money )

	local cp = math.fmod(money, 100);
	money = (money - cp) / 100;
	local sp = math.fmod(money, 1000);
	local gp = (money - sp) / 1000;
	
	return (gp .. "g " .. sp .. "s " .. cp .. "c");
end

function saveData()

	local currentCash = playerAttributes:GetMoney();
	playerList[playerName] = currentCash;

	Turbine.PluginData.Save(Turbine.DataScope.Server, "Cash_Playerlist", playerList);

end

Turbine.Plugin.Unload = function (sender, args)

	saveData();

end

function loadData()

	playerList = Turbine.PluginData.Load(Turbine.DataScope.Server, "Cash_Playerlist");
	
	local currentCash = playerAttributes:GetMoney();
	playerList[playerName] = currentCash;


end
	
-- setup variables
localPlayer = Turbine.Gameplay.LocalPlayer:GetInstance();
playerName = localPlayer:GetName();
playerAttributes = localPlayer:GetAttributes();
initialCash = playerAttributes:GetMoney();

loadData();

Turbine.Shell.WriteLine("cash v" .. Plugins["Cash"]:GetVersion() .. " by packetlss loaded.");

shellCommands();
